package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.MemberCoin;
import com.izouma.awesomeadmin.service.MemberCoinService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * controller类
 */
@Controller
@RequestMapping("/memberCoin")
@RequiresAuthentication
public class MemberCoinController {

    @Autowired
    private MemberCoinService memberCoinService;

    /**
     * <p>获取全部记录。</p>
     */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(MemberCoin record) {
        List<MemberCoin> pp = memberCoinService.getMemberCoinList(record);
        return new Result(true, pp);
    }

    /**
     * <p>根据Id。</p>
     */
    @RequestMapping(value = "/getMemberCoin", method = RequestMethod.GET)
    @ResponseBody
    public Result getMemberCoin(@RequestParam(required = false, value = "id") String id) {
        MemberCoin data = memberCoinService.getMemberCoinById(id);
        return new Result(true, data);
    }

    /**
     * <p>根据条件获取。</p>
     */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(MemberCoin record) {
        MemberCoin data = memberCoinService.getMemberCoin(record);
        return new Result(true, data);
    }


    /**
     * <p>分页查询。</p>
     */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, MemberCoin record) {
        Map<String, Object> result = new HashMap<>();

        List<MemberCoin> pp = memberCoinService.getMemberCoinByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
     * <p>保存。</p>
     */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(MemberCoin record) {
        boolean num = memberCoinService.createMemberCoin(record);
        if (num) {
            return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
     * <p>更新信息。</p>
     */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateMemberCoin(MemberCoin record) {
        boolean num = memberCoinService.updateMemberCoin(record);
        if (num) {
            return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
     * <p>删除。</p>
     */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteMemberCoin(@RequestParam(required = true, value = "id") String id) {

        boolean num = memberCoinService.deleteMemberCoin(id);
        if (num) {
            return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
     * 导出Excel
     *
     * @param request
     * @param response
     * @param record
     * @throws Exception
     */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, MemberCoin record) throws Exception {

        List<MemberCoin> memberCoins = memberCoinService.getMemberCoinList(record);


        String sheetName = "member_coin";
        String titleName = "用户余额数据表";
        String fileName = "用户余额表";
        int columnNumber = 12;
        int[] columnWidth = {20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20};
        String[] columnName = {"", "删除标识", "更新时间", "更新人", "创建时间", "创建人", "用户", "订单", "变动金额", "剩余金额", "类型", "备注"};
        String[][] dataList = new String[memberCoins.size()][12];

        for (int i = 0; i < memberCoins.size(); i++) {

            dataList[i][0] = String.valueOf(memberCoins.get(i).getId());
            dataList[i][1] = String.valueOf(memberCoins.get(i).getDelFlag());
            dataList[i][2] = String.valueOf(memberCoins.get(i).getUpdateTime());
            dataList[i][3] = String.valueOf(memberCoins.get(i).getUpdateUser());
            dataList[i][4] = String.valueOf(memberCoins.get(i).getCreateTime());
            dataList[i][5] = String.valueOf(memberCoins.get(i).getCreateUser());
            dataList[i][6] = String.valueOf(memberCoins.get(i).getUserId());
            dataList[i][7] = String.valueOf(memberCoins.get(i).getOrderId());
            dataList[i][8] = String.valueOf(memberCoins.get(i).getMoney());
            dataList[i][9] = String.valueOf(memberCoins.get(i).getBalance());
            dataList[i][10] = String.valueOf(memberCoins.get(i).getTypeFlag());
            dataList[i][11] = String.valueOf(memberCoins.get(i).getRemark());
        }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
                columnNumber, columnWidth, columnName, dataList, response);


    }

    @RequestMapping(value = "/song", method = RequestMethod.POST)
    @ResponseBody
    public Result song(MemberCoin memberCoin) {

        int num = memberCoinService.song(memberCoin);
        if (num > 0) {
            return new Result(true, "赠送成功");
        }
        return new Result(false, "赠送异常");

    }

}

